"""
Name: basechecker.py
Date: 10-28-13
Author: Catherine Doyle
    
Description: Checks pairing between two nucleotides in a riboswitch sequence. Opens file containing riboswitches and calls Unafold. Opens pairing file from Unafold and checks pairing between certain nucleotides. The program saves riboswitch sequences with the correct pairing. 
    """
#!/usr/bin/python
import sys
import string
import os
import subprocess
# Open files and intialize sequences
infile = open("47-26rbs1.txt", "r")# Open file containing riboswitches 
inflie = infile.readlines()# Reads the file containing riboswitches
infile.close()# Close input file
base = []# Initalizes a list of sequences 
# Checks pairing between the RBS and start codon
for line in infile:
    line= line.strip("\n")
    line1 = line.split("(")
    for switch in line1[0:-1]:# Select only the riboswitch sequence from the line in the infile
        out = open('outRiboD.txt', "w")# Open a file to write invidual riboswitches to
        out.write(switch)# Write invidual riboswitches to outputfile
        out.close()# Close output file
        subprocess.call(['/Users/macampbell/Desktop/unafolddata/bin/UnaFold.pl','--X=50','outRiboD.txt'])# # Call Unafold. Give Unafold the file containing the riboswitch and set suboptimality to 50 
        pairingfile = open('outRiboD.txt.ct')# Open Unafold pairing output file
        header = pairingfile.readline()# Remove header from pairing output file
        pairingfile = pairingfile.readlines()# Read the rest of the pairing output file
        for matrix in pairingfile:
            if "dG" not in matrix:# Only read lines that contain pairing values
                matrix = matrix.strip("\n")
                one, two, three, four, five, six, seven, eight = matrix.split("\t")# Split the line in file into invidual columms
                if (one == "48" and five == "25"):# Check to pairing between two nucleotides
                    if line not in base:# Check to make sure sequence is not already in pairing list
                    base.append(line)# append riboswitch sequence to pairing list
# Print sequences in pairing list
for line in base:
   print line
