"""
Name: freenergycalculator.py
Date: 10-28-13
Author: Catherine Doyle
    
Description: Identifies riboswitches with a difference in free energy between the ON and OFF foldings that is less than -9.2 kcal/mol. 
Takes the free energy of the aptamer sequence and opens the file containing all iterations of riboswitch sequences. For each riboswitch sequence in the file calls Unafold and calculates the free energy of
    the riboswitch in the absence and presence of the ligand. If the difference in free energy is less thant the energy of the aptamer the riboswitch and free energy are saved.  
"""
#!/usr/bin/python
import sys
import string
import subprocess
# User inputs
FE = raw_input('Enter free energy of aptamer: ') # Asks the user to input the free energy of the aptamer in the riboswitch
FE = -float(FE)# Converts the raw_input to a float for calculations
# Intilization and Opening of files
free_energy = {} # Initilize a dictionary of riboswitches with a difference in free energy less than the aptamer
ribofile = open("outcombo-5-12.txt", "r")# Opens the file containing the iterations of riboswitches
ribofile = ribofile.readlines()# Reads the file containing the iterations of riboswithces
ribofile.close()# Close riboswitch file
# Calcualte folding and free energy of the ON and OFF states
for line in ribofile:
    line = line.split(" ")# For each line in the riboswitch file split at the space to grab one riboswitch sequence
    for switch in line[0:-1]:# Cut each riboswitch from the line removing the space
        out = open('outRibo.txt', "w")# Open a file to write invidual riboswitches to
        out.write(switch)# Write invidual riboswitches to outputfile
        out.close()# Close output file
        subprocess.call(['/Users/macampbell/Desktop/unafolddata/bin/UnaFold.pl','--X=50','outRibo.txt'])# Call Unafold. Give Unafold the file containing the riboswitch and set suboptimality to 50 
        dg1= open("outRibo.txt.dG", "r")# Open Unafold free energy output file
        header = dg1.readline() # Remove header from free energy output file
        dg1 = dg1.readlines()# Read the rest of the free energy output file
        for line in dg1:
            temp,dg1,Z = seq.split("\t")# Split each line in the free energy file to separte temperature, free energy, and Z values
                subprocess.call(['/Users/macampbell/Desktop/unafolddata/bin/hybrid-ss-min','--prohibit=39,0,21','outRibo.txt'])# Call Unafold. Give Unafold the file containing the riboswitch and prohibit binding of the RBS and start codon
                dg2= open("outRibo.txt.dG", "r")# Open Unafold free energy output file
                header = dg2.readline() # Remove header from free enerfy output file
                dg2 = dg2.readlines()# Read the rest of the free energy output file
                for line in dg2:# Loop through the lines
                        temp,dg2,Z = line.split("\t")# Split each line in the free energy file to separte temperature, free energy, and Z values
                        if ((float(dg2)) - (float(dg1))) < FE:# Take the difference between the ON and OFF values 
                                free_energy[switch] = dg1,dg2 # If the difference in free energy is less than the inputted free energy of the apatmer store riboswtich sequence and free energy in a dictionary                
                        
# Print the riboswitch sequences and free energy values with a difference in free energy less than the inputted free energy of the apatmer           
for riboseq in free_energy: 
        print riboseq,free_energy[line]
                
               
    

                
